import { system, world } from '@minecraft/server';

system.runInterval(() => {
    let skeletons =
        world.getDimension('overworld').getEntities({families:['skeleton']}).concat(
            world.getDimension('nether').getEntities({families:['skeleton']}),
            world.getDimension('the_end').getEntities({families:['skeleton']})
        )

    skeletons.forEach(entity => {
        if (entity.getDynamicProperty("java:strafe_direction") === undefined) entity.setDynamicProperty("java:strafe_direction", Math.random() * 360)
        else entity.setDynamicProperty("java:strafe_direction", (entity.getDynamicProperty("java:strafe_direction") + 5) % 360)

        const strafeDirRadians = entity.getDynamicProperty("java:strafe_direction") * (Math.PI / 180)

        entity.applyImpulse({
            x: Math.cos(strafeDirRadians) * 0.05,
            y: 0,
            z: Math.sin(strafeDirRadians) * 0.05
        })
    })
})